# TestableMock

Write mock faster, make unit testing easier.

Any test framework, no initialization, no matter private method, static method, construction method, or any other method of any class, and no matter how the object created.
Write a mock method, add an `@MockInvoke` annotation, everything is done.

Usage Document: https://alibaba.github.io/testable-mock/#/en-us/

## Roadmap

`TestableMock` is still under heavy development, the following version plans may be adjusted during the iteration

- `v0.6` it's the current version, refer to the [issue](https://github.com/alibaba/testable-mock/issues) list for the work in progress
- `v0.7` better anti-refactoring support of mocking, allow quick mock all method in specified class
- `v1.0` all functions are stable, a brand-new start

## Directory Structure

```bash
|-- testable-parent       ➜ Provide parent pom file shared by other modules
|-- testable-all          ➜ Dependence aggration, for easily import all modules at once
|-- testable-processor    ➜ Compile-time code preprocessing module, provides test assist functions
|-- testable-agent        ➜ JavaAgent module, provides test mocking related functions
|-- testable-core         ➜ Basic function module, provides mock related class and annotation
|-- testable-maven-plugin ➜ Maven plugin module, for simplify JavaAgent injection
|-- tool                  ➜ Scripts for project maintain
|-- demo
|   |-- java-demo         ➜ Java code example
|   `-- kotlin-demo       ➜ Kotlin code example
`-- docs                  ➜ Source code of usage document
```

## Build project

The project is built using JDK 1.6+ and Maven 3+, except for the `demo` sub-project requires JDK 1.8+.

```bash
mvn clean install
```

## Generate document

```bash
docsify serve docs
```

> `TestableMock` document is generated by `docsify` tool, please install [nodejs](https://nodejs.org/en/download/) before execution, and run `npm install -g docsify` command to install the tool required.
